Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/symboltables/functionPanels/firstlayerfeature/FirstLayerFeatureAditionalPanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/symboltables/functionPanels/firstlayerfeature/FirstLayerFeatureAditionalPanel.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/symboltables/functionPanels/firstlayerfeature/FirstLayerFeatureAditionalPanel.java	(revision 44259)
@@ -23,7 +23,6 @@
 import org.gvsig.app.project.symboltables.ProjectSymbolTable;
 import org.gvsig.expressionevaluator.Expression;
 import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingLocator;
-import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingManager;
 import org.gvsig.expressionevaluator.swing.ExpressionPickerController;
 import org.gvsig.expressionevaluator.swing.JExpressionBuilder;
 import org.gvsig.fmap.dal.DALLocator;
@@ -136,7 +135,7 @@
 
 
         this.featureSymbolTable = dataManager.createFeatureSymbolTable();
-        this.storeElement = dataSwingManager.createFeatureStoreElement(this.picketFilter);
+        this.storeElement = dataSwingManager.createFeatureStoreElement();
         this.picketFilter.addElement(this.storeElement);
     }
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/documents/view/expressionevaluator/viewcapturepoint/ViewCapturePointElement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/documents/view/expressionevaluator/viewcapturepoint/ViewCapturePointElement.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/documents/view/expressionevaluator/viewcapturepoint/ViewCapturePointElement.java	(revision 44259)
@@ -27,6 +27,7 @@
     public ViewCapturePointElement() {
         super(
                 ToolsLocator.getI18nManager().getTranslation("_Capture_point"),
+                null, 
                 "expressionbuilder-element-view-capture-point"
         );
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/documents/view/expressionevaluator/savedpoints/SavedPointsElement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/documents/view/expressionevaluator/savedpoints/SavedPointsElement.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/documents/view/expressionevaluator/savedpoints/SavedPointsElement.java	(revision 44259)
@@ -29,23 +29,16 @@
             extends AbstractElement
             implements ConstantElement {
 
-        private final Object value;
-
         public PointEntryElement(Object value, String name) {
-            super(name, "expressionbuilder-element-constant");
-            this.value = value;
+            super(name, value, "expressionbuilder-element-constant");
         }
 
-        @Override
-        public Object getValue() {
-            return value;
-        }
     }
 
     private final List<Element> childs;
 
     public SavedPointsElement() {
-        super(ToolsLocator.getI18nManager().getTranslation("Saved points"), "view-query-coordinate-capture");
+        super(ToolsLocator.getI18nManager().getTranslation("Saved points"), null, "view-query-coordinate-capture");
 
         ExpressionEvaluatorSwingManager evManager = ExpressionEvaluatorSwingLocator.getManager();
         TemporaryStorageManager manager = TemporaryStorageLocator.getTemporaryStorageManager();
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/documents/view/expressionevaluator/ViewLayersElement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/documents/view/expressionevaluator/ViewLayersElement.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/project/documents/view/expressionevaluator/ViewLayersElement.java	(revision 44259)
@@ -31,7 +31,7 @@
         private final FLayer layer;
         
         public LayerEntryElement(ViewDocument view, FLayer layer) {
-            super(layer.getName(), "expressionbuilder-element-constant");
+            super(layer.getName(), layer.getName(), "expressionbuilder-element-constant");
             this.layer = layer;
         }
 
@@ -54,7 +54,7 @@
             FLayer layer = it.next();
             if( layer instanceof SingleLayer ) {
                 if( layer instanceof FLyrVect ) {
-                    FeatureStoreElement e = dalSwingManager.createFeatureStoreElement(null);
+                    FeatureStoreElement e = dalSwingManager.createFeatureStoreElement();
                     e.setFeatureStore(((FLyrVect) layer).getFeatureStore());
                     e.setName(layer.getName());
                     this.childs.add(e);
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/extension/SearchByAttributesExtension.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/extension/SearchByAttributesExtension.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/java/org/gvsig/app/extension/SearchByAttributesExtension.java	(revision 44259)
@@ -0,0 +1,72 @@
+package org.gvsig.app.extension;
+
+import org.gvsig.andami.plugins.Extension;
+import org.gvsig.app.ApplicationLocator;
+import org.gvsig.app.ApplicationManager;
+import org.gvsig.app.project.documents.view.ViewDocument;
+import org.gvsig.app.project.documents.view.gui.IView;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.dal.swing.DALSwingLocator;
+import org.gvsig.fmap.dal.swing.DataSwingManager;
+import org.gvsig.fmap.dal.swing.searchpanel.FeatureStoreSearchPanel;
+import org.gvsig.fmap.mapcontext.layers.FLayer;
+import org.gvsig.fmap.mapcontext.layers.vectorial.FLyrVect;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.swing.api.ToolsSwingLocator;
+import org.gvsig.tools.swing.api.windowmanager.WindowManager;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class SearchByAttributesExtension extends Extension {
+
+    @Override
+    public void initialize() {
+    }
+
+    @Override
+    public void execute(String actionCommand) {
+        ApplicationManager application = ApplicationLocator.getManager();
+
+        IView view = (IView) application.getActiveComponent(ViewDocument.class);
+        if (view == null) {
+            return;
+        }
+        if ("search-by-attributes-layer".equals(actionCommand)) {
+            DataSwingManager dataSwingManager = DALSwingLocator.getSwingManager();
+            WindowManager winManager = ToolsSwingLocator.getWindowManager();
+            
+            ViewDocument document = view.getViewDocument();
+
+            FLayer layer = document.getMapContext().getLayers().getActives()[0];
+            String title = "Search: " + layer.getName();
+            FeatureStore featureStore = ((FLyrVect) layer).getFeatureStore();
+            
+            FeatureStoreSearchPanel panel = dataSwingManager.createFeatureStoreSearchPanel(featureStore);
+            winManager.showWindow(
+                    panel.asJComponent(), 
+                    title, 
+                    WindowManager.MODE.WINDOW
+            );
+            
+        }
+    }
+
+    @Override
+    public boolean isEnabled() {
+        return true;
+    }
+
+    @Override
+    public boolean isVisible() {
+        ApplicationManager application = ApplicationLocator.getManager();
+
+        IView view = (IView) application.getActiveComponent(ViewDocument.class);
+        if (view == null) {
+            return false;
+        }
+        ViewDocument document = view.getViewDocument();
+        return document.getMapContext().hasActiveVectorLayers();
+    }
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app.document.table.app/org.gvsig.app.document.table.app.mainplugin/src/main/java/org/gvsig/app/extension/SelectByAttributesInTableExtension.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app.document.table.app/org.gvsig.app.document.table.app.mainplugin/src/main/java/org/gvsig/app/extension/SelectByAttributesInTableExtension.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app.document.table.app/org.gvsig.app.document.table.app.mainplugin/src/main/java/org/gvsig/app/extension/SelectByAttributesInTableExtension.java	(revision 44259)
@@ -79,18 +79,19 @@
         if ("selection-by-attributes-table".equals(actionCommand)) {
             table = (FeatureTableDocumentPanel) v;
 
-            featureStore = table.getModel().getStore();
-            filterTitle = table.getModel().getName();
-            table.getModel().setModified(true);
+            
+            featureStore = table.getFeatureStore();
+            filterTitle = featureStore.getName();
+//            table.getModel().setModified(true);
             SelectByAttributes selector = new SelectByAttributes();
             selector.showWindow(filterTitle, featureStore, WindowManager.MODE.TOOL);
             
         } else if ("selection-by-attributes-table-old".equals(actionCommand)) {
             table = (FeatureTableDocumentPanel) v;
 
-            featureStore = table.getModel().getStore();
-            filterTitle = table.getModel().getName();
-            table.getModel().setModified(true);
+            featureStore = table.getFeatureStore();
+            filterTitle = featureStore.getName();
+//            table.getModel().setModified(true);
 
             doExecute();
         }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.fmap.control/src/main/java/org/gvsig/fmap/mapcontrol/dal/feature/swing/FeatureTypesTablePanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.fmap.control/src/main/java/org/gvsig/fmap/mapcontrol/dal/feature/swing/FeatureTypesTablePanel.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.fmap.control/src/main/java/org/gvsig/fmap/mapcontrol/dal/feature/swing/FeatureTypesTablePanel.java	(revision 44259)
@@ -25,7 +25,6 @@
 
 import java.awt.BorderLayout;
 import java.awt.Dimension;
-import java.util.List;
 import javax.swing.DefaultListModel;
 import javax.swing.JComponent;
 
@@ -34,6 +33,7 @@
 import javax.swing.JList;
 import javax.swing.event.ListSelectionEvent;
 import javax.swing.event.ListSelectionListener;
+import org.gvsig.fmap.dal.DataStore;
 
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.feature.Feature;
@@ -46,6 +46,7 @@
 import org.gvsig.fmap.mapcontrol.dal.feature.swing.table.SelectedFeatureTypeChangeListener;
 import org.gvsig.tools.exception.BaseException;
 import org.gvsig.tools.swing.api.ListElement;
+import org.gvsig.tools.util.UnmodifiableBasicMap;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
@@ -134,8 +135,8 @@
     }
 
     private boolean hasManyFeatureTypes() throws DataException {
-        List<String> childNames = this.model.getFeatureStore().getChildrenNames();
-        if( childNames!=null && !childNames.isEmpty() ) {
+        UnmodifiableBasicMap<String, DataStore> children = this.model.getFeatureStore().getChildren();
+        if( !children.isEmpty() ) {
             return true;
         }
         return typesControl.getFeatureTypesSize() > 1;
@@ -241,8 +242,8 @@
         DefaultListModel model = new DefaultListModel();
         FeatureStore store = this.model.getFeatureStore();
         model.addElement(new ListElement<>(store.getName(),store));
-        for (String childName : store.getChildrenNames()) {
-            model.addElement(new ListElement<>(childName,store.getChild(childName)));
+        for (String childName : store.getChildren().keySet() ) {
+            model.addElement(new ListElement<>(childName,store.getChildren().get(childName)));
         }
         l.setModel(model);
         l.addListSelectionListener(new ListSelectionListener() {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.main/src/main/java/org/gvsig/expressionevaluator/main/MainDialog.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.main/src/main/java/org/gvsig/expressionevaluator/main/MainDialog.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.main/src/main/java/org/gvsig/expressionevaluator/main/MainDialog.java	(revision 44259)
@@ -49,7 +49,7 @@
                 openStore()
         );
         if( element != null ) {
-            panel.getElements().add(element);
+            panel.addElement(element);
         }
         Dialog dialog = windowManager.createDialog(
                 panel.asJComponent(),
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java	(revision 44259)
@@ -743,6 +743,11 @@
     }
 
     @Override
+    public boolean isEmpty() {
+        return value == null;
+    }
+    
+    @Override
     public ExpressionBuilder createExpressionBuilder() {
         return new DefaultExpressionBuilder();
     }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionBuilder.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.api/src/main/java/org/gvsig/expressionevaluator/ExpressionBuilder.java	(revision 44259)
@@ -536,4 +536,5 @@
 
     public Function toStr(Value object);
 
+    public boolean isEmpty();
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/ExpressionEvaluatorSwingManager.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/ExpressionEvaluatorSwingManager.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/ExpressionEvaluatorSwingManager.java	(revision 44259)
@@ -3,22 +3,21 @@
 
 import java.util.Collection;
 import java.util.List;
+import javax.lang.model.element.VariableElement;
 import javax.swing.JButton;
-import javax.swing.JPanel;
 import javax.swing.text.JTextComponent;
 import org.gvsig.expressionevaluator.Function;
 import org.gvsig.expressionevaluator.SymbolTable;
 import org.gvsig.expressionevaluator.swing.Element.ConstantElement;
 import org.gvsig.expressionevaluator.swing.Element.FunctionElement;
 import org.gvsig.expressionevaluator.swing.Element.GroupElement;
-import org.gvsig.expressionevaluator.swing.Element.VariableElement;
 
 public interface ExpressionEvaluatorSwingManager {
 
     
 //    public List<Element> createElements(Collection<SymbolTable> symbolTables);
     
-    public List<Element> createElements(ExpressionBuilderConfig config, Collection<SymbolTable> symbolTables);
+    public List<Element> createElements(Collection<SymbolTable> symbolTables);
     
     public JExpressionBuilder createJExpressionBuilder();
     
@@ -48,18 +47,16 @@
 //
 //    public VariableElement createVariableElement(String label, String source, String name, String typeName, String description);
 
-    public GroupElement createGroupElement(ExpressionBuilderConfig config, String name);
+    public GroupElement createGroupElement(String name);
     
-    public GroupElement createGroupElement(ExpressionBuilderConfig config, String name, List<Element> elements);
+    public GroupElement createGroupElement(String name, List<Element> elements);
 
-    public FunctionElement createFunctionElement(ExpressionBuilderConfig config, Function function);
+    public FunctionElement createFunctionElement(Function function);
 
-    public ConstantElement createConstantElement(ExpressionBuilderConfig config, Object value);
+    public ConstantElement createConstantElement(Object value, String label);
 
-    public ConstantElement createConstantElement(ExpressionBuilderConfig config, Object value, String description);
+    public ConstantElement createConstantElement(Object value, String label, String description);
 
-    public VariableElement createVariableElement(ExpressionBuilderConfig config, String label, String source, String name, String typeName, String description);
-
     public ExpressionPickerController createExpressionPickerController(JTextComponent text, JButton button);
 
     public CalculatorController createCalculatorController(JTextComponent text, int dataType);
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/Element.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/Element.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/Element.java	(revision 44259)
@@ -5,12 +5,13 @@
 import javax.swing.ImageIcon;
 import org.gvsig.expressionevaluator.Function;
 import org.gvsig.tools.swing.api.Component;
+import org.gvsig.tools.util.LabeledValue;
 
 /**
  *
  * @author jjdelcerro
  */
-public interface Element {
+public interface Element extends LabeledValue, Comparable {
 
     public interface SimpleElement extends Element {
 
@@ -43,25 +44,16 @@
 
     public interface ConstantElement extends SimpleElement {
 
-        public Object getValue();
     }
 
     public interface CalculatedElement extends SimpleElement {
 
-        public Object getValue();
     }
 
-    public interface VariableElement extends SimpleElement {
-
-        public String getSource();
-
-        public String getLabel();
-
-        public String getTypeName();
-    }
-
     public String getName();
-
+    
+    public String getRenderedValue();
+    
     public String getDescription();
 
     public String getIconName();
@@ -73,4 +65,10 @@
     public boolean isEnabled();
 
     public void reload();
+    
+    public void used();
+    
+    public Element setConfig(ExpressionBuilderConfig config);
+    
+    public ExpressionBuilderConfig getConfig();
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/spi/AbstractElement.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/spi/AbstractElement.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/spi/AbstractElement.java	(revision 44259)
@@ -1,5 +1,6 @@
 package org.gvsig.expressionevaluator.swing.spi;
 
+import java.util.Objects;
 import javax.swing.ImageIcon;
 import org.gvsig.expressionevaluator.swing.Element;
 import org.gvsig.expressionevaluator.swing.ExpressionBuilderConfig;
@@ -18,16 +19,31 @@
 
     protected static final Logger LOGGER = LoggerFactory.getLogger(AbstractElement.class);
     
-    final String name;
+    final Object value;
     final String iconName;
     final ImageIcon icon;
+    private final String name;
+    private ExpressionBuilderConfig config;
 
     protected AbstractElement(String name) {
-        this(name,null);
+        this(name, name, null);
     }
     
-    protected AbstractElement(String name, String iconName) {
-        this.name = name;
+    protected AbstractElement(String name, Object value) {
+        this(name, value, null);
+    }
+    
+    protected AbstractElement(String name, Object value, String iconName) {
+        if( name == null ) {
+            this.name = Objects.toString(value);
+        } else {
+            this.name = name;
+        }
+        if( value == null ) {
+            this.value = name;
+        } else {
+            this.value = value;
+        }
         this.iconName = iconName;
         IconTheme theme = ToolsSwingLocator.getIconThemeManager().getCurrent();
         if( theme.exists(iconName) ) {
@@ -38,18 +54,62 @@
             this.icon = theme.get("expressionbuilder-element");
         }
     }
+
+    @Override
+    public Element setConfig(ExpressionBuilderConfig config) {
+        this.config = config;
+        return this;
+    }
     
     @Override
+    public ExpressionBuilderConfig getConfig() {
+        return this.config;
+    }
+    
+    @Override
     public String getName() {
         return this.name;
     }
+    
+    @Override
+    public Object getValue() {
+        return this.value;
+    }
 
     @Override
+    public String getRenderedValue() {
+        return Objects.toString(this.value);
+    }
+
+    @Override
     public String getDescription() {
         return null;
     }
 
     @Override
+    public String getLabel() {
+        return Objects.toString(this.value, "");
+    }
+
+    @Override
+    @SuppressWarnings("StringEquality")
+    public int compareTo(Object other) {
+        String otherLabel = null;
+        if( other!=null ) {
+            otherLabel = other.toString();
+        }
+        String thisLabel = this.getLabel();
+        if (thisLabel== otherLabel) {
+            return 0;
+        } else if (thisLabel== null) {
+            return -1;
+        } else if (otherLabel == null) {
+            return 1;
+        }
+        return thisLabel.compareTo(otherLabel);        
+    }
+    
+    @Override
     public String getIconName() {
         return iconName;
     }
@@ -58,6 +118,10 @@
     public ImageIcon getIcon() {
         return this.icon;
     }
+
+    @Override
+    public void used() {
+    }
     
     @Override
     public Component getAditionalPanel(JExpressionBuilder expressionBuilder) {
@@ -66,7 +130,7 @@
 
     @Override
     public String toString() {
-        return this.getName();
+        return this.getLabel();
     }
 
     @Override
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/ExpressionBuilderConfig.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/ExpressionBuilderConfig.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.api/src/main/java/org/gvsig/expressionevaluator/swing/ExpressionBuilderConfig.java	(revision 44259)
@@ -9,25 +9,43 @@
  *
  * @author jjdelcerro
  */
-public interface ExpressionBuilderConfig extends PropertiesSupport {
+public interface ExpressionBuilderConfig  {
 
+    public interface Preferences extends PropertiesSupport {
+        /**
+         * Time in secons to use when obtains the list of elements.
+         * 
+         * @return time in secons
+         */
+        public int getSimpleElementsLimit();
+
+        /**
+         * Set the time in secons to use to obtain the list of elements.
+         * 
+         * @param limit 
+         */
+        public void setSimpleElementsLimit(int limit);
+
+        public void setScriptsEnabled(boolean enabled);
+
+        public boolean getScriptsEnabled();
+
+        public void setSQLCompatible(boolean sqlCompatible);
+
+        public boolean isSQLCompatible();
+        
+        public boolean getShowLabelsOfElements();
+        
+        public void setShowLabelsOfElements(boolean showLabels);
+        
+    }
+    
+    public Preferences getPreferences();
+    
     public List<Element> getElements();
 
     public void addElement(Element element);
-    /**
-     * Time in secons to use when obtains the list of elements.
-     * 
-     * @return time in secons
-     */
-    public int getSimpleElementsLimit();
 
-    /**
-     * Set the time in secons to use to obtain the list of elements.
-     * 
-     * @param limit 
-     */
-    public void setSimpleElementsLimit(int limit);
-
     public Collection<SymbolTable> getSymbolTables();
 
     public void addSymbolTable(SymbolTable symbolTable);
@@ -38,15 +56,8 @@
 
     public void removeAllSymbolTables();
     
-    public void setScriptsEnabled(boolean enabled);
-    
-    public boolean getScriptsEnabled();
-    
     public SymbolTable getPreviewSymbolTable();
     
     public void setPreviewSymbolTable(SymbolTable symbolTable);
     
-    public void setSQLCompatible(boolean sqlCompatible);
-    
-    public boolean isSQLCompatible();
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/AbstractAutomaticExpressionChecker.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/AbstractAutomaticExpressionChecker.java	(revision 44258)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.swing/org.gvsig.expressionevaluator.swing.impl/src/main/java/org/gvsig/expressionevaluator/swing/impl/AbstractAutomaticExpressionChecker.java	(revision 44259)
@@ -51,7 +51,7 @@
     private static final Color COLOR_ERROR = new Color(255,225,232);
 
     private final JTextComponent text;
-    private final ExpressionBuilderConfig config;
+    private final ExpressionBuilderConfig builderConfig;
 
     private Color color_ok;
     private Timer timerExpression;
@@ -69,7 +69,7 @@
 
     public AbstractAutomaticExpressionChecker(ExpressionBuilderConfig config, JTextComponent theText) {
         this.text = theText;
-        this.config = config;
+        this.builderConfig = config;
         this.initComponents();
     }
 
@@ -162,7 +162,7 @@
     }
     
     private void doCheckExpression() {
-        if( this.text == null || this.config == null ) {
+        if( this.text == null || this.builderConfig == null ) {
             return;
         }
         Expression expression = this.getExpression();
@@ -184,7 +184,7 @@
         }
         final Mutable<String> theTip = new MutableObject<>(null);
         expression.setSQLCompatible(false);
-        if (this.config.getPreviewSymbolTable() == null) {
+        if (this.builderConfig.getPreviewSymbolTable() == null) {
             try {
                 ExpressionEvaluatorManager theManager = ExpressionEvaluatorLocator.getManager();
                 MutableSymbolTable symbolTable = theManager.createSymbolTable();
@@ -195,7 +195,7 @@
             }
         } else {
             try {
-                Object theValue = expression.execute(this.config.getPreviewSymbolTable());
+                Object theValue = expression.execute(this.builderConfig.getPreviewSymbolTable());
                 this.setPreview(theValue);
             } catch (ExpressionRuntimeException ex) {
                 theTip.setValue(ex.getTip());
@@ -204,7 +204,7 @@
                 this.setMessage(JOptionPane.ERROR_MESSAGE, "Runtime error. " + ex.getMessage());
             }
         }
-        if( this.config.isSQLCompatible() ) {
+        if( this.builderConfig.getPreferences().isSQLCompatible() ) {
             Code code = expression.getCode();
             try {
                 code.accept(new Visitor() {
@@ -219,8 +219,8 @@
                                 }
                                 break;
                             case Code.IDENTIFIER:
-                                if( config.getPreviewSymbolTable()!=null && 
-                                        !config.getPreviewSymbolTable().isSQLCompatible(((Identifier)code).name()) ) {
+                                if( builderConfig.getPreviewSymbolTable()!=null && 
+                                        !builderConfig.getPreviewSymbolTable().isSQLCompatible(((Identifier)code).name()) ) {
                                     theTip.setValue(I18N.Avoid_the_use_of_functions_not_compatible_with_SQL_in_this_data_source(((Identifier)code).name()));
                                 }
                                 break;
